Loading...
Searching...
No Matches
apr_anylock.h File Reference

APR-Util transparent any lock flavor wrapper. More...

`#include "apr_proc_mutex.h"`
`#include "apr_thread_mutex.h"`
`#include "apr_thread_rwlock.h"`
Include dependency graph for apr_anylock.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | apr_anylock_t
union | apr_anylock_t::apr_anylock_u_t

## Macros

#define | APR_ANYLOCK_LOCK(lck)
#define | APR_ANYLOCK_TRYLOCK(lck)
#define | APR_ANYLOCK_UNLOCK(lck)

## Typedefs

typedef struct apr_anylock_t | apr_anylock_t

## Detailed Description

APR-Util transparent any lock flavor wrapper.

## Macro Definition Documentation

## APR_ANYLOCK_LOCK

#define APR_ANYLOCK_LOCK | ( |  | lck | ) |

Value:
(((lck)->type == apr_anylock_none) \
? APR_SUCCESS \
: (((lck)->type == apr_anylock_threadmutex) \
? apr_thread_mutex_lock((lck)->lock.tm) \
: (((lck)->type == apr_anylock_procmutex) \
? apr_proc_mutex_lock((lck)->lock.pm) \
: (((lck)->type == apr_anylock_readlock) \
? apr_thread_rwlock_rdlock((lck)->lock.rw) \
: (((lck)->type == apr_anylock_writelock) \
? apr_thread_rwlock_wrlock((lck)->lock.rw) \
: APR_EINVAL)))))

Lock an apr_anylock_t structure

## APR_ANYLOCK_TRYLOCK

#define APR_ANYLOCK_TRYLOCK | ( |  | lck | ) |

Value:
(((lck)->type == apr_anylock_none) \
? APR_SUCCESS \
: (((lck)->type == apr_anylock_threadmutex) \
? apr_thread_mutex_trylock((lck)->lock.tm) \
: (((lck)->type == apr_anylock_procmutex) \
? apr_proc_mutex_trylock((lck)->lock.pm) \
: (((lck)->type == apr_anylock_readlock) \
? apr_thread_rwlock_tryrdlock((lck)->lock.rw) \
: (((lck)->type == apr_anylock_writelock) \
? apr_thread_rwlock_trywrlock((lck)->lock.rw) \
: APR_EINVAL)))))

Try to lock an apr_anylock_t structure

## APR_ANYLOCK_UNLOCK

#define APR_ANYLOCK_UNLOCK | ( |  | lck | ) |

Value:
(((lck)->type == apr_anylock_none) \
? APR_SUCCESS \
: (((lck)->type == apr_anylock_threadmutex) \
? apr_thread_mutex_unlock((lck)->lock.tm) \
: (((lck)->type == apr_anylock_procmutex) \
? apr_proc_mutex_unlock((lck)->lock.pm) \
: ((((lck)->type == apr_anylock_readlock) || \
((lck)->type == apr_anylock_writelock)) \
? apr_thread_rwlock_unlock((lck)->lock.rw) \
: APR_EINVAL))))

Unlock an apr_anylock_t structure

## Typedef Documentation

## apr_anylock_t

typedef struct apr_anylock_t apr_anylock_t

Structure that may contain any APR lock type